# Native Build Tools
![](https://github.com/graalvm/native-build-tools/actions/workflows/test-native-gradle-plugin.yml/badge.svg)
![](https://github.com/graalvm/native-build-tools/actions/workflows/test-native-maven-plugin.yml/badge.svg)

Repository which contains build tool plugins for interoperability with [GraalVM Native Image](https://www.graalvm.org/reference-manual/native-image/).

End-user documentation about the plugins can be found [here](https://graalvm.github.io/native-build-tools/).

## Contributing
### Projects
 * [native-maven-plugin](native-maven-plugin/README.md)
 * [native-gradle-plugin](native-gradle-plugin/README.md)

### Common subprojects
 * [junit-platform-native](common/junit-platform-native/README.md)

### Getting Started

* [Getting Started with the Maven Plugin](https://graalvm.github.io/native-build-tools/latest/maven-plugin-quickstart.html)
* [Getting Started with the Gradle Plugin](https://graalvm.github.io/native-build-tools/latest/gradle-plugin-quickstart.html)

### Samples

Examples can be found in the [samples subdirectory](samples).

### Contributing Code
We welcome your code contributions. To get started, you will need to sign the [Oracle Contributor Agreement](https://oca.opensource.oracle.com) (OCA).

Only pull requests from committers that can be verified as having signed the OCA can be accepted.
